#ifndef _DEV_CONFIG_H_
#define _DEV_CONFIG_H_
/***********************************************************************************************************************
			------------------------------------------------------------------------
			|\\\																///|
			|\\\					Hardware interface							///|
			------------------------------------------------------------------------
***********************************************************************************************************************/
#ifdef USE_BCM2835_LIB
    #include <bcm2835.h>
#elif USE_WIRINGPI_LIB
    #include <wiringPi.h>
    #include <wiringPiSPI.h>
	#include <wiringPiI2C.h>
#elif USE_DEV_LIB
    #include "RPI_sysfs_gpio.h"
    #include "dev_hardware_SPI.h"
    #include "dev_hardware_i2c.h"   
#endif

#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <unistd.h>
#include "Debug.h"

#define IIC_CMD        0X00
#define IIC_RAM        0X40


/**
 * data
**/
#define UBYTE   uint8_t
#define UWORD   uint16_t
#define UDOUBLE uint32_t

//LCD Define
#define LCD_CS         8		
#define LCD_RST        27	
#define LCD_DC         22	
#define LCD_BL         18

#define KEY_1         4
#define KEY_2         17
#define KEY_3         23
#define KEY_4         24

#define LCD_CS_0      DEV_Digital_Write(LCD_CS,0)
#define LCD_CS_1      DEV_Digital_Write(LCD_CS,1)

#define LCD_RST_0      DEV_Digital_Write(LCD_RST,0)
#define LCD_RST_1      DEV_Digital_Write(LCD_RST,1)

#define LCD_DC_0       DEV_Digital_Write(LCD_DC,0)
#define LCD_DC_1       DEV_Digital_Write(LCD_DC,1)

#define LCD_BL_0		DEV_Digital_Write(LCD_BL,0)
#define LCD_BL_1		DEV_Digital_Write(LCD_BL,1)


/*------------------------------------------------------------------------------------------------------*/

UBYTE DEV_ModuleInit(void);
void  DEV_ModuleExit(void);

void DEV_SetBacklight(UWORD Value);
void DEV_GPIO_Mode(UWORD Pin, UWORD Mode);
void DEV_Digital_Write(UWORD Pin, UBYTE Value);
UBYTE DEV_Digital_Read(UWORD Pin);
void DEV_Delay_ms(UDOUBLE xms);

void I2C_Write_Byte(uint8_t value, uint8_t Cmd);
void DEV_SPI_WriteByte(UBYTE Value);
void DEV_SPI_Write_nByte(uint8_t *pData, uint32_t Len);

#endif
